glibmm: Gio::SocketConnection Class Reference

glibmm 2.32.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions
Gio::SocketConnection Class Reference
Portable Network I/O Functionality

A socket connection. More...

`#include <giomm/socketconnection.h>`

Inheritance diagram for Gio::SocketConnection:
[legend]

List of all members.

## Public Member Functions
virtual | ~SocketConnection ()
GSocketConnection* | gobj ()
| Provides access to the underlying C GObject.
const GSocketConnection* | gobj () const
| Provides access to the underlying C GObject.
GSocketConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< Socket > | get_socket ()
| Gets the underlying Socket object of the connection.
Glib::RefPtr< const Socket > | get_socket () const
| Gets the underlying Socket object of the connection.
Glib::RefPtr< SocketAddress > | get_local_address ()
| Try to get the local address of a socket connection.
Glib::RefPtr< const SocketAddress > | get_local_address () const
| Try to get the local address of a socket connection.
Glib::RefPtr< SocketAddress > | get_remote_address ()
| Try to get the remote address of a socket connection.
Glib::RefPtr< const SocketAddress > | get_remote_address () const
| Try to get the remote address of a socket connection.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Socket > > | property_socket () const
| The underlying GSocket.
Public Member Functions inherited from Gio::IOStream
virtual | ~IOStream ()
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object.
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object.
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Closes a stream.
bool | is_closed () const
| Checks if a stream is closed.
bool | has_pending () const
| Checks if a stream has pending actions.
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable (const trackable &src)
trackable & | operator= (const trackable &src)
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | remove_destroy_notify_callback (void *data) const
void | notify_callbacks ()

## Static Public Member Functions
static Glib::RefPtr < SocketConnection > | create (const Glib::RefPtr< Socket >& socket)
| Creates a SocketConnection subclass of the right type for socket.

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::SocketConnection > | wrap (GSocketConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Detailed Description

A socket connection.

See also:
  IOStream, SocketClient, SocketListener

SocketConnection is a IOStream for a connected socket. They can be created either by SocketClient when connecting to a host, or by SocketListener when accepting a new client.

The type of the SocketConnection object returned from these calls depends on the type of the underlying socket that is in use. For instance, for a TCP/IP connection it will be a TcpConnection.

Chosing what type of object to construct is done with the socket connection factory, and it is possible for 3rd parties to register custom socket connection types for specific combination of socket family/type/protocol using g_socket_connection_factory_register_type().

Since glibmm 2.24:

## Constructor & Destructor Documentation

virtual Gio::SocketConnection::~SocketConnection | ( |  | ) |
| virtual

## Member Function Documentation

static Glib::RefPtr<SocketConnection> Gio::SocketConnection::create | ( | const Glib::RefPtr< Socket >& | socket | ) |
| static

Creates a SocketConnection subclass of the right type for socket.

Since glibmm 2.22:

Returns:
  A SocketConnection.

Glib::RefPtr<SocketAddress> Gio::SocketConnection::get_local_address | ( |  | ) |

Try to get the local address of a socket connection.

Since glibmm 2.22:

Returns:
  A SocketAddress or `0` on error. Free the returned object with Glib::object_unref().

Glib::RefPtr<const SocketAddress> Gio::SocketConnection::get_local_address | ( |  | ) | const

Try to get the local address of a socket connection.

Since glibmm 2.22:

Returns:
  A SocketAddress or `0` on error. Free the returned object with Glib::object_unref().

Glib::RefPtr<SocketAddress> Gio::SocketConnection::get_remote_address | ( |  | ) |

Try to get the remote address of a socket connection.

Since glibmm 2.22:

Returns:
  A SocketAddress or `0` on error. Free the returned object with Glib::object_unref().

Glib::RefPtr<const SocketAddress> Gio::SocketConnection::get_remote_address | ( |  | ) | const

Try to get the remote address of a socket connection.

Since glibmm 2.22:

Returns:
  A SocketAddress or `0` on error. Free the returned object with Glib::object_unref().

Glib::RefPtr<Socket> Gio::SocketConnection::get_socket | ( |  | ) |

Gets the underlying Socket object of the connection.

This can be useful if you want to do something unusual on it not supported by the SocketConnection APIs.

Since glibmm 2.22:

Returns:
  A SocketAddress or `0` on error.

Glib::RefPtr<const Socket> Gio::SocketConnection::get_socket | ( |  | ) | const

Gets the underlying Socket object of the connection.

This can be useful if you want to do something unusual on it not supported by the SocketConnection APIs.

Since glibmm 2.22:

Returns:
  A SocketAddress or `0` on error.

GSocketConnection* Gio::SocketConnection::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::IOStream.

Reimplemented in Gio::UnixConnection, and Gio::TcpConnection.

const GSocketConnection* Gio::SocketConnection::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::IOStream.

Reimplemented in Gio::UnixConnection, and Gio::TcpConnection.

GSocketConnection* Gio::SocketConnection::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::IOStream.

Reimplemented in Gio::UnixConnection, and Gio::TcpConnection.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Socket> > Gio::SocketConnection::property_socket | ( |  | ) | const

The underlying GSocket.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::SocketConnection > wrap | ( | GSocketConnection * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.